<?php
/*
Plugin Name: Instagram Feed by Expert Village Media
Plugin URI: http://www.expertvillagemedia.com
Description: A plugin that Display customizable and clean Instagram feeds
Version: 1.2
Author: EVM
Author URI: http://www.expertvillagemedia.com
*/
?>
<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
include dirname( __FILE__ ) .'/evm-instagram-feed-admin.php';

//Run function on plugin activate
function evm_instagram_activate() 
{  
    $options = get_option('evm_instagram_settings');
    $options[ 'evm_instagram_loadmore' ] = true;
    $options['evm_instagram_title'] = "Instagram Feeds";
    update_option( 'evm_instagram_settings', $options );
}
register_activation_hook( __FILE__, 'evm_instagram_activate' );

//Uninstall
function evm_instagram_uninstall()
{
    if ( ! current_user_can( 'activate_plugins' ) )
        return;
    //If the user is preserving the settings then don't delete them
    $options = get_option('evm_instagram_settings');
    $evm_instagram_retain_settings = $options[ 'evm_instagram_retain_settings' ];
    if($evm_instagram_retain_settings=='Yes') return;
    //Settings
    delete_option( 'evm_instagram_settings' );
}
register_deactivation_hook( __FILE__, 'evm_instagram_uninstall' );

//Allows shortcodes
add_filter('widget_text', 'do_shortcode');

add_shortcode( 'evm-instagram', 'evm_instagram_shortcode');
function evm_instagram_shortcode( $atts ) 
{
    ob_start();
    $options = get_option('evm_instagram_settings');
    $atts = shortcode_atts( array(
    'title' => empty($options[ 'evm_instagram_title' ]) ? '' : $options[ 'evm_instagram_title' ],
    'accesstoken' => empty($options[ 'evm_instagram_accesstoken' ]) ? '' : $options[ 'evm_instagram_accesstoken' ],
    'limit'=>empty($options[ 'evm_instagram_num' ]) ? '20' : $options[ 'evm_instagram_num' ],
    'size'=>empty($options[ 'evm_instagram_size' ]) ? 'large' : $options[ 'evm_instagram_size' ],
    'cols'=>empty($options[ 'evm_instagram_cols' ]) ? '4' : $options[ 'evm_instagram_cols' ],
    'sort'=>empty($options[ 'evm_instagram_sort' ]) ? 'asc' : $options[ 'evm_instagram_sort' ]
    ), $atts, 'evm-instagram' );
    $title = $atts['title'];
    $accesstoken = $atts['accesstoken'];
    $limit = $atts['limit'];
    $size = 'large';
    $cols = $atts['cols'];
    $target = $atts['target'];
    $sort = $atts['sort'];
    // Display the Feeds
    echo '<div class="evmtitle">';
    // Check if title is set
    if ( $title )
    {
      echo '<h1>'.$title.'</h1>' ;
    }  
    
    $username = get_username($accesstoken);

    if ( is_wp_error( $username ) ) 
    {
        echo wp_kses_post( $username->get_error_message() );
    }
    else
    {
        echo '<h2><a href="https://instagram.com/'.$username.'">@'.$username.'</a></h2>' ;
        if($limit>20)
        {
            $limit =20;
        }
        $feed_array = get_instagram_feed( $accesstoken ,$limit);

        if ( is_wp_error( $feed_array ) ) 
        {
          echo wp_kses_post( $feed_array->get_error_message() );
        }
        else
        {        
        if ( $images_only = apply_filters( 'evm_images_only', FALSE ) ) 
        {
          $feed_array = array_filter( $feed_array, array( $this, 'evm_images_only' ) );
        }
       
        if($sort=='asc')
        {
             ksort($feed_array);
        }
        else
        {
            krsort($feed_array);
        }
        // filters for custom classes       
        $liclass = apply_filters( 'evm_item_class', 'instagram-size-'.$cols );
        if($size=='large')
        {
           $imgclass = apply_filters( 'evm_item_sizeclass', 'evm_item_size-'.$cols );
        }
        else
        {
            $imgclass = apply_filters( 'evm_item_sizeclass', 'evm_item_size-11');
        }
        ?>
        <div class="carouselGallery-grid hidden-xs evm_main_div" align="center">
            <div class="carouselGallery-col-100"> 
           
              <?php
              $i=0;
               foreach ( $feed_array as $item ) 
               {         
                echo '<div  class="'. esc_attr( $liclass ) .' evm_image_div carouselGallery-carousel carouselGallery-col-1" 
                 data-posturl="'.$item['link'].'"><a href="'.$item['link'].'"  target="_blank"  class="'. esc_attr( $aclass ) .'"><img src="'. esc_url( $item[$size] ) .'"  alt="'. esc_attr( $item['description'] ) .'" title="'. esc_attr( $item['description'] ).'"  class="'. esc_attr( $imgclass ) .' evm_image_div_class"/></a></div>';
                ?>
                <?php  
                $i++;       
            }
            $evm_instagram_follow_btn_styles = 'style="';
            $evm_instagram_follow_btn_styles .= 'background: #0085ba; ';
            $evm_instagram_follow_btn_styles .= 'color: #ffffff;';
            $evm_instagram_follow_btn_styles .= '"';
            ?>
            </div>                  
        </div>
        <div class="evm_follow_btn">
            <a href="http://instagram.com/<?php echo $username;?>" <?php echo  $evm_instagram_follow_btn_styles;?> target="_blank">
                <i class="fa fa-instagram"></i>
                <?php echo Follow;?>
            </a>
        </div> 
        <?php
      }
    }
    echo '</div>';
    $ReturnString = ob_get_contents(); ob_end_clean(); return $ReturnString;
}

function get_instagram_feed($accesstoken,$count)
{
    $url = 'https://api.instagram.com/v1/users/self/media/recent/?access_token='.$accesstoken.'&count='.$count;

    $curl_connection = curl_init($url);
    curl_setopt($curl_connection, CURLOPT_CONNECTTIMEOUT, 30);
    curl_setopt($curl_connection, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl_connection, CURLOPT_SSL_VERIFYPEER, false);

    //Data are stored in $data
    $result = json_decode(curl_exec($curl_connection), true);
    $code = $result['meta']['code'];
    curl_close($curl_connection);
   
    if ( 200 != $result['meta']['code'])
          return new WP_Error( 'invalid_response', esc_html__( 'Instagram did not return a 200.', 'evm-instagram-widget' ) );  
    if ( !$result)
          return new WP_Error( 'site_down', esc_html__( 'Unable to communicate with Instagram.', 'evm-instagram-widget' ) );
      
    $images= $result['data'];
    $instagramFeeds = array();
    foreach($images as $key=>$image)
    {
        $thumbnail = $image['images']['thumbnail']['url'];
        $small = $image['images']['low_resolution']['url'];
        $large = $image['images']['standard_resolution']['url'];      

        $feedcaption = 'Instagram Image';
        if ( ! empty( $image['caption']['text'] ) ) 
        {
            $feedcaption = $image['caption']['text'];
        }
        $type = $image['type'];
        $instagramFeeds[] = array(
        'description' => $feedcaption,
        'username' => $image['caption']['from']['username'],
        'link'        => $image['link'] ,
        'time'        => $image['created_time'],
        'comments'    => $image['comments']['count'],
        'likes'       => $image['likes']['count'],
        'thumbnail'   => $thumbnail ,
        'small'       => $small,
        'large'       => $large,
        'type'        => $type,
        'next_url'    => $result['pagination']['next_url']
        ); 
    }
    return $instagramFeeds;
}

function get_username($accesstoken)
{
    if(empty($accesstoken))
    {
      return new WP_Error( 'bad_json', esc_html__( 'Access token missing.', 'evm-instagram-widget' ) );
    }
    $response = wp_remote_get( 'https://api.instagram.com/v1/users/self/?access_token='.$accesstoken);

    if ( is_wp_error( $response ) )
      return new WP_Error( 'site_down', esc_html__( 'Unable to communicate with Instagram.', 'evm-instagram-widget' ) );

    $body_array = json_decode($response['body']);

    if (! $body_array )
      return new WP_Error( 'bad_json', esc_html__( 'Instagram has returned invalid data.', 'evm-instagram-widget' ) );

    if($body_array->data)
    {
      $bodydata = $body_array->data;
      return $username = $bodydata->username;
    }
}  

//Enqueue stylesheet front
add_action( 'wp_enqueue_scripts', 'evm_instagram_styles_enqueue_front' );
function evm_instagram_styles_enqueue_front() 
{
    wp_enqueue_script( 'evm_insta_script',  plugin_dir_url( __FILE__ ) . 'js/main.js', false, NULL, 'all' );    
    wp_enqueue_style( 'evm_insta_styles',  plugin_dir_url( __FILE__ ) . 'css/evm-insta_front.css', false, NULL, 'all' );
    wp_enqueue_style( 'evm_insta_mainstyles',  plugin_dir_url( __FILE__ ) . 'css/main.css', false, NULL, 'all' );    
}
?>