<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

function evm_instagram_menu() {
    add_menu_page(
        'EVM Instagram Feed',
        'EVM Instagram Feed',
        'manage_options',
        'evm-instagram-feed',
        'evm_instagram_settings_page'
    );
    add_submenu_page(
        'evm-instagram-feed',
        'Settings',
        'Settings',
        'manage_options',
        'evm-instagram-feed',
        'evm_instagram_settings_page'
    );
}
add_action('admin_menu', 'evm_instagram_menu');
function evm_instagram_settings_page() 
{
    //Declare defaults
    $evm_instagram_general_settings_hidden_field = 'evm_instagram_general_settings_hidden_field';
    $evm_instagram_custom_hidden_field           = 'evm_instagram_custom_hidden_field';
    $evm_instagram_settings_defaults = array(
        'evm_instagram_title'       =>'Instagram',
        'evm_instagram_accesstoken' => '',
        'evm_instagram_num'         => '20',
        'evm_instagram_cols'        => '4',
        'evm_instagram_size'        => 'large',
        'evm_instagram_sort'        => 'asc',       
        'evm_instagram_retain_settings'=>true,
        
    );
    //Save defaults in an array
    $options = wp_parse_args(get_option('evm_instagram_settings'), $evm_instagram_settings_defaults);    
    update_option( 'evm_instagram_settings', $options );

    //Set the page variables
    $evm_instagram_title = $options[ 'evm_instagram_title' ];
    $evm_instagram_accesstoken = $options[ 'evm_instagram_accesstoken' ];
    $evm_instagram_num = $options[ 'evm_instagram_num' ];
    $evm_instagram_cols = $options[ 'evm_instagram_cols' ];
    $evm_instagram_size = $options[ 'evm_instagram_size' ];
    $evm_instagram_sort = $options[ 'evm_instagram_sort' ];
    $evm_instagram_retain_settings = $options['evm_instagram_retain_settings'];
   
    //save setting data for get feeds 
     if ( ! isset( $_POST['evm_instagram_settings_nonce'] ) || ! wp_verify_nonce( $_POST['evm_instagram_settings_nonce'], 'evm_instagram_saving_settings' ) ) 
     {
        //Nonce did not verify
     } 
    else 
    {
        //  post setting data.

        if( isset($_POST[ $evm_instagram_general_settings_hidden_field ]) && $_POST[ $evm_instagram_general_settings_hidden_field ] == 'Y' ) 
        {            
            $evm_instagram_accesstoken = sanitize_text_field( $_POST[ 'evm_instagram_accesstoken' ] );            
            $evm_instagram_retain_settings = sanitize_text_field( $_POST[ 'evm_instagram_retain_settings' ]) ;          
            $evm_default_feed_page = sanitize_text_field($_POST['evm_default_feed_page']);
            $evm_default_feed_page_location = sanitize_text_field($_POST['evm_default_feed_page_location']);
            $options[ 'evm_instagram_retain_settings' ]= $evm_instagram_retain_settings;
            $options[ 'evm_instagram_accesstoken' ]        = $evm_instagram_accesstoken;        
             
        }
        if(isset($_POST[ $evm_instagram_custom_hidden_field ]) && $_POST[ $evm_instagram_custom_hidden_field ] == 'Y' )
        {
            $evm_instagram_title = sanitize_text_field( $_POST[ 'evm_instagram_title' ] );
            $evm_instagram_num = sanitize_text_field( $_POST[ 'evm_instagram_num' ] );
            $evm_instagram_cols = sanitize_text_field( $_POST[ 'evm_instagram_cols' ] );
            $evm_instagram_size = sanitize_text_field( $_POST[ 'evm_instagram_size' ] );
            $evm_instagram_sort = sanitize_text_field( $_POST[ 'evm_instagram_sort' ] );
            $options[ 'evm_instagram_title' ]                = $evm_instagram_title;
            $options[ 'evm_instagram_num' ]                = $evm_instagram_num;
            $options[ 'evm_instagram_cols' ]               = $evm_instagram_cols;
            $options[ 'evm_instagram_size' ]               = $evm_instagram_size;
            $options[ 'evm_instagram_target' ]             = $evm_instagram_target;
            $options[ 'evm_instagram_sort' ]               = $evm_instagram_sort;
            $options[ 'evm_instagram_retain_settings' ]    = $evm_instagram_retain_settings;
        }
         update_option( 'evm_instagram_settings', $options );
         ?>
          <div class="updated"><p><strong><?php _e('Settings saved.', 'instagram-feed' ); ?></strong></p></div>
          <?php
    }
?>

<div id="evm_admin" class="wrap">
        <div id="header">
            <h1><?php _e('EVM INSTAGRAM FEED', 'instagram-feed'); ?></h1>
        </div>
         <?php $active_tab = isset( $_GET[ 'tab' ] ) ? $_GET[ 'tab' ] : 'general_setting'; ?>
            <h4 class="nav-tab-wrapper">
            <a href="?page=evm-instagram-feed&tab=general_setting" class="nav-tab <?php echo $active_tab == 'general_setting' ? 'nav-tab-active' : ''; ?>"><?php _e('GENERAL SETTING', 'instagram-feed'); ?></a>
            <a href="?page=evm-instagram-feed&tab=customization" class="nav-tab <?php echo $active_tab == 'customization' ? 'nav-tab-active' : ''; ?>"><?php _e('CUSTOMIZATION', 'instagram-feed'); ?></a>
             <a href="?page=evm-instagram-feed&tab=support" class="nav-tab <?php echo $active_tab == 'support' ? 'nav-tab-active' : ''; ?>"><?php _e('SUPPORT', 'instagram-feed'); ?></a>
            <a href="?page=evm-instagram-feed&tab=proversion" class="nav-tab nav-tab-pro <?php echo $active_tab == 'proversion' ? 'nav-tab-active' : ''; ?>"><?php _e('PRO VERSION', 'instagram-feed'); ?></a>
            

            <a href="?page=evm-instagram-feed&tab=statistics" class="nav-tab nav-tab-pro <?php echo $active_tab == 'statistics' ? 'nav-tab-active' : ''; ?>"><?php _e('STATISTICS', 'instagram-feed'); ?></a>
           
            </h4>    
        <form name="form1" method="post" action="">
            <?php wp_nonce_field( 'evm_instagram_saving_settings', 'evm_instagram_settings_nonce' ); ?> 
            <?php
                if($active_tab == 'general_setting')
                {
            ?> 
            <input type="hidden" name="<?php echo $evm_instagram_general_settings_hidden_field; ?>" value="Y">     
                   
            <div class="evm_admin_left evm_admin_left_width">
            <div id="evm_config">                    
                <a href="https://outofthesandbox.com/pages/instagram-access-token" class="button button-primary" target="_blank"><?php _e('GENERATE ACCESS TOKEN', 'instagram-feed'); ?></a>  
            </div> 
            <table class="form-table">
                <tbody>                   
                    <tr valign="top">
                        <th scope="row"><label><?php _e('Access Token', 'instagram-feed'); ?></label></th>
                        <td>
                            <input name="evm_instagram_accesstoken" id="evm_instagram_accesstoken" type="text" value="<?php esc_attr_e( $evm_instagram_accesstoken, 'instagram-feed' ); ?>" size="50" maxlength="60" placeholder="Click button above to get your Access Token" />
                            &nbsp;
                                <div class="tooltip">
                                    <a class="evm_tooltip_link" href="JavaScript:void(0);">
                                    <?php _e("What is this?", 'instagram-feed'); ?>                                
                                    </a>
                                    <span class="tooltiptext">
                                    <?php _e("This token allows the plugin to securely access your Instagram profile, for the purpose of displaying your Instagram photo feed in your Website.", 'instagram-feed'); ?> </span>
                                </div>
                        </td>
                    </tr> 

                     <tr>
                        <th class="bump-left"><label for="evm_instagram_retain_settings" class="bump-left"><?php _e("Retain settings when plugin is removed", 'instagram-feed'); ?></label></th>
                        <td>
                            <select name="evm_instagram_retain_settings">
                                <option <?php if($evm_instagram_retain_settings=='Yes') {echo "selected";}?> value="Yes"><?php _e('Yes', 'instagram-feed'); ?></option>
                                 <option <?php if($evm_instagram_retain_settings=='No') {echo "selected";}?> value="No"><?php _e('No', 'instagram-feed'); ?></option>
                            </select>
                        </td>
                    </tr>
            </tbody>
            </table>
            <?php
            submit_button(); 
            ?>
            </div>
            <div class="evmcustomize evm_admin_right">            
                <?php
                    echo 'Use below shortcode on Post or Pages<br>
                     to display your Instagram feeds                  
                    <p>[evm-instagram]</p>
                    <p>Or</p>
                    <p>[evm-instagram limit="10" cols="2"]</p>        
                    ';
                ?>                    
            </div>
            <?php
                }
            if($active_tab == 'customization')
                {
            ?>            
            <div class="evm_admin_left evm_admin_left_width">
            <input type="hidden" name="<?php echo $evm_instagram_custom_hidden_field?>" value="Y">
            <table class="form-table">
                <tbody> 
                <tr valign="top">
                    <th scope="row"><label><?php _e('Title', 'instagram-feed'); ?></label></th>
                    <td>
                        <input name="evm_instagram_title" type="text" value="<?php esc_attr_e( $evm_instagram_title, 'instagram-feed' ); ?>" size="30" maxlength="25" />
                       
                    </td>
                </tr>             
                    <tr valign="top">
                    <th scope="row"><label><?php _e('Number of Photos', 'instagram-feed'); ?></label></th>
                    <td>
                        <input name="evm_instagram_num" type="number" value="<?php esc_attr_e( $evm_instagram_num, 'instagram-feed' ); ?>" min="1" max="20" size="4" maxlength="4" />
                         <span class="evmcustomize"><a href=" https://www.expertvillagemedia.com/coming-soon/" target="_blank">Upgrade to Pro for more than 20 photo</a></span> 
                       
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><label><?php _e('Number of Columns', 'instagram-feed'); ?></label></th>
                    <td>
                        <select name="evm_instagram_cols">
                            <option value="1" <?php if($evm_instagram_cols == "1") echo 'selected="selected"' ?> ><?php _e('1', 'instagram-feed'); ?></option>
                            <option value="2" <?php if($evm_instagram_cols == "2") echo 'selected="selected"' ?> ><?php _e('2', 'instagram-feed'); ?></option>
                            <option value="3" <?php if($evm_instagram_cols == "3") echo 'selected="selected"' ?> ><?php _e('3', 'instagram-feed'); ?></option>
                            <option value="4" <?php if($evm_instagram_cols == "4") echo 'selected="selected"' ?> ><?php _e('4', 'instagram-feed'); ?></option>
                            <option value="5" <?php if($evm_instagram_cols == "5") echo 'selected="selected"' ?> ><?php _e('5', 'instagram-feed'); ?></option>
                            <option value="6" <?php if($evm_instagram_cols == "6") echo 'selected="selected"' ?> ><?php _e('6', 'instagram-feed'); ?></option>
                            <option value="7" <?php if($evm_instagram_cols == "7") echo 'selected="selected"' ?> ><?php _e('7', 'instagram-feed'); ?></option>
                            <option value="8" <?php if($evm_instagram_cols == "8") echo 'selected="selected"' ?> ><?php _e('8', 'instagram-feed'); ?></option>
                            <option value="9" <?php if($evm_instagram_cols == "9") echo 'selected="selected"' ?> ><?php _e('9', 'instagram-feed'); ?></option>
                            <option value="10" <?php if($evm_instagram_cols == "10") echo 'selected="selected"' ?> ><?php _e('10', 'instagram-feed'); ?></option>
                        </select>
                    </td>
                </tr>

                <tr valign="top">
                    <th scope="row"><label><?php _e('Photo size', 'instagram-feed'); ?></label></th>
                    <td>
                        <select name="evm_instagram_size">
                            <option value="thumbnail" <?php if($evm_instagram_size == "thumbnail") echo 'selected="selected"' ?><?php selected( 'thumbnail', $evm_instagram_size ) ?>><?php esc_html_e( 'Thumbnail', 'evm-instagram-widget' ); ?></option>
                            <option value="small" <?php if($evm_instagram_size == "small") echo 'selected="selected"' ?><?php selected( 'small', $evm_instagram_size ) ?>><?php esc_html_e( 'Small', 'evm-instagram-widget' ); ?></option>
                            <option value="large" <?php if($evm_instagram_size == "large") echo 'selected="selected"' ?><?php selected( 'large', $evm_instagram_size ) ?>><?php esc_html_e( 'Full size', 'evm-instagram-widget' ); ?></option>
                                                        
                        </select>

                    </td>
                </tr>

                <tr valign="top">
                    <th scope="row"><label><?php _e('Order by', 'instagram-feed'); ?></label></th>
                    <td>
                        <select name="evm_instagram_sort">
                            <option value="asc" <?php if($evm_instagram_sort == "asc") echo 'selected="selected"' ?><?php selected( 'asc', $evm_instagram_sort ) ?>><?php esc_html_e( 'Newest to Oldest', 'evm-instagram-widget' ); ?></option>
                             <option value="desc" <?php if($evm_instagram_sort == "desc") echo 'selected="selected"' ?><?php selected( 'desc', $evm_instagram_sort ) ?>><?php esc_html_e( 'Oldest to Newest', 'evm-instagram-widget' ); ?></option>                          
                        </select>
                    </td>
                </tr>                    
                </tbody>
            </table>
            <hr>
            <p><strong>Free version</strong>: Only 20 images allowed.</p>
            <?php
            submit_button();                             
            ?>
            </div>
            <div class="evmcustomize evm_admin_right">            
                <?php               
                    echo 'Use below shortcode on Post or Pages<br>
                     to display your Instagram feeds                  
                    <p>[evm-instagram]</p>
                    <p>Or</p>
                    <p>[evm-instagram limit="10" cols="2"]</p>            
                    ';
                ?>                    
            </div>
            <?php
        }
        if($active_tab == 'proversion')
        {
            ?><div class="evmcustomize"><a href=" https://www.expertvillagemedia.com/coming-soon/" target="_blank">Upgrade to Pro to enable More options</a></div>
            <div class="evm_admin_left border_class">
            <div id="evm_accordion">              

                <h3>LOAD MORE BUTTON</h3>
                <div>                
                    <table class="form-table">
                        <tbody>
                            <tr valign="top">
                            <th scope="row" ><label><?php _e('Show Load More Button', 'instagram-feed'); ?>: </label></th>
                            <td>
                                <input type="checkbox" name="loadmore" value="">                              
                            </td>
                            </tr>
                            <tr valign="top">
                            <th scope="row" ><label><?php _e('Button background colour', 'instagram-feed'); ?>: </label></th>
                            <td>
                                <input type="checkbox" name="loadmore" value="">                              
                            </td>

                            </tr>

                            <tr valign="top">
                            <th scope="row" ><label><?php _e('Button text colour', 'instagram-feed'); ?>: </label></th>
                            <td>
                                <input type="checkbox" name="loadmore" value="">                              
                            </td>
                            </tr>

                            <tr valign="top">
                            <th scope="row" ><label><?php _e('Button text', 'instagram-feed'); ?>: </label></th>
                            <td>
                                <input name="evm_instagram_loadmore_text" type="text" value="<?php esc_attr_e( 'Load More..', 'instagram-feed' ); ?>" size="50" maxlength="25" >                              
                            </td>
                            </tr>

                            <tr valign="top">
                            <th colspan="2"><input type="button" disabled name="save" value="Save" class="button button-primary"></th>
                           
                            </tr>    
                        </tbody>
                    </table>
                </div>
                <h3>HASHTAG</h3>
               <div>
                    <table class="form-table">
                        <tbody>
                            <tr valign="top">
                            <th scope="row" style="width: 45px;"><label><?php _e('hashtag', 'instagram-feed'); ?>: </label></th>
                            <td>
                                <input name="evm_instagram_title" type="text" value="<?php esc_attr_e( '#cute', 'instagram-feed' ); ?>" size="50" maxlength="25" />
                               
                            </td>
                            </tr>  
                            <tr valign="top">
                            <th colspan="2"><input type="button" disabled name="save" value="Save" class="button button-primary"></th>
                           
                            </tr>    
                        </tbody>
                    </table>
                </div>
                <h3>CAROUSEL</h3>
               <div>
                    <table class="form-table">
                        <tbody>
                            <tr valign="top">
                            <th scope="row" ><label><?php _e('Display as a carousel', 'instagram-feed'); ?>: </label></th>
                            <td>
                                <input type="checkbox" name="evm_carousel" value="">                              
                            </td>
                            </tr>
                            <tr valign="top">
                            <th scope="row" ><label><?php _e('Navigation Button', 'instagram-feed'); ?>: </label></th>
                            <td>
                                <input type="checkbox" name="evm_carousel_navigation" value="">                              
                            </td>
                            </tr>

                            <tr valign="top">
                            <th scope="row" ><label><?php _e('Autoplay', 'instagram-feed'); ?>: </label></th>
                            <td>
                                <input type="checkbox" name="evm_carousel_autoplay" value="">                              
                            </td>
                            </tr>

                            <tr valign="top">
                            <th scope="row" ><label><?php _e('Carousel time', 'instagram-feed'); ?>: </label></th>
                            <td>
                                <input name="evm_carousel_time" type="text" value="<?php esc_attr_e( '1000', 'instagram-feed' ); ?>" size="10" maxlength="25" >                              
                            </td>
                            </tr>

                            <tr valign="top">
                            <th colspan="2"><input type="button" disabled name="save" value="Save" class="button button-primary"></th>
                           
                            </tr>    
                        </tbody>
                    </table>
                </div>               
            </div>
            </div>
            <?php
        }
        if($active_tab == 'statistics')
        {
           echo '<div class="evmcustomize"><a href=" https://www.expertvillagemedia.com/coming-soon/" target="_blank">Upgrade to Pro to enable More options</a></div><div class="evm_admin_left border_class">
                    <p>
                    <img src="'.plugin_dir_url( __FILE__ ).'images/original.jpg" style="width: 100%;">
                    </p>
                </div>';
        }
        if($active_tab == 'support')
        {
            echo '<div class="evm_admin_left border_class"><p><i class="fa fa-envelope" aria-hidden="true"></i>&nbsp; Need help? Please <a href="https://www.expertvillagemedia.com/wordpress-plugin-support/" target="_blank">Click here</a> for all support requests.</p>
                <hr>
                <span>
                    <a href="https://www.facebook.com/expertvillagemedia">
                        <img src="'.plugin_dir_url( __FILE__ ).'images/F.png" >
                    </a> 
                    <a href="https://twitter.com/expertvillageme">
                        <img src="'.plugin_dir_url( __FILE__ ).'images/T.png" >
                    </a> 
                    <a href="https://www.pinterest.com/expertvillage/">
                        <img src="'.plugin_dir_url( __FILE__ ).'images/P.png" >
                    </a> 
                    <a href="https://www.linkedin.com/company/expert-village-media-technologies">
                        <img src="'.plugin_dir_url( __FILE__ ).'images/In.png" >
                    </a>
                </span>
            </div>';
        }

            ?>
        </form> 

       <!--  <div class="clear"></div>
        <div class="evmcustomize"><a href=" https://www.expertvillagemedia.com/coming-soon/" target="_blank">Upgrade to Pro to enable More options</a></div>   -->     
<?php
}

// Add a Settings link to the plugin on the Plugins page
$evm_plugin_file = 'evm-insta-feed/evm-insta-feed.php';
add_filter( "plugin_action_links_{$evm_plugin_file}", 'evm_add_settings_link', 10, 2 );
 
//modify the link
function evm_add_settings_link( $links, $file ) {
    $evm_settings_link = '<a href="' . admin_url( 'admin.php?page=evm-instagram-feed' ) . '">' . __( 'Settings', 'evm-instagram-feed', 'instagram-feed' ) . '</a>';
    array_unshift( $links, $evm_settings_link ); 
    return $links;
}

//Enqueue stylesheet front
add_action( 'admin_enqueue_scripts', 'evm_instagram_styles_enqueue_admin' );
function evm_instagram_styles_enqueue_admin() 
{  
    wp_enqueue_script( 'jquery-ui-accordion' );
    wp_enqueue_style( 'evm_insta_admin_tab_styles', plugin_dir_url( __FILE__ ) . 'css/admin_tab_ui.css', false, NULL, 'all');
    wp_enqueue_script( 'jquery-admin' ,plugin_dir_url( __FILE__ ) . 'js/main_admin.js', false, NULL, 'all');
    wp_enqueue_style( 'evm_insta_admin_styles',  plugin_dir_url( __FILE__ ) . 'css/evm-insta_admin.css', false, NULL, 'all' );
}
?>